<?php

namespace TDevAgency\Cms\Events;

use Illuminate\Broadcasting\InteractsWithSockets;
use Illuminate\Broadcasting\PrivateChannel;
use Illuminate\Foundation\Events\Dispatchable;
use Illuminate\Http\Request;
use Illuminate\Queue\SerializesModels;
use TDevAgency\Cms\Models\BaseModels\Post;

class PostSaveEvent
{
    use Dispatchable;
    use InteractsWithSockets;
    use SerializesModels;

    public $post;
    public $request;

    /**
     * Create a new event instance.
     *
     * @return void
     */
    public function __construct(Post $post, Request $request)
    {
        $this->post = $post;
        $this->request = $request;
    }

    /**
     * Get the channels the event should broadcast on.
     *
     * @return \Illuminate\Broadcasting\Channel|array
     */
    public function broadcastOn()
    {
        return new PrivateChannel('channel-name');
    }
}
