<?php

namespace TDevAgency\Cms\Traits;

use TDevAgency\Cms\Models\BaseModels\Post;
use TDevAgency\Cms\Models\BaseModels\PostConnection;

trait CategoryTrait
{
    public function categories(int $id): array
    {
        $categories = Post::where('post_type', Post::CATEGORY_TYPE)
            ->where('id', '!=', $id)
            ->whereDoesntHave('parentCategories')->with(['adminChildrenCategories', 'adminLocalization'])->get();

        $selectedCategories = PostConnection::where('post_id', $id)->pluck('post_parent_id')->toArray();
        return [$categories, $selectedCategories];
    }
}
