<?php

namespace TDevAgency\Cms\Traits;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Facades\Request;

/**
 * Trait Searchable
 *
 * Simple trait for searching in the admin area
 *
 * @package TDevAgency\Cms\Traits
 */
trait Searchable
{
    public function scopeSearch(Builder $query): void
    {
        if (Request::query('q') !== null && trim(Request::query('q')) !== '' && $this->searchable !== null) {
            $sql = [];
            foreach ($this->searchable as $field) {
                $sql[] = "{$field} LIKE '%" . trim(Request::query('q')) . "%'";
            }
            $query->whereRaw('(' . implode(" OR ", $sql) . ')');
        }
    }

    public function scopeSearchApi(Builder $query)
    {
        if (Request::post('query') !== null && trim(Request::post('query')) !== '' && $this->searchable !== null) {
            $sql = [];
            foreach ($this->searchable as $field) {
                $sql[] = "{$field} LIKE '%" . trim(Request::post('query')) . "%'";
            }
            $query->whereRaw('(' . implode(" OR ", $sql) . ')');
        }
    }
}
